var lastSelectedSwatch;
var instructions;
var isOn = false;
// Save Reference to Script Name 
var scriptName		= "Background_Dimmer";
// Script Version
var scriptVersion	= "10.0.1";
// Last Modified
var lastModified	= "2016-09-29";
// Last Modified
var lastUploaded	= "2016-09-29";
// Block Id
var blockId			= 6148;
// Establish Boolean for Tracking
var trackOnce = true;
// Call Init Method once AdKit is loaded    
adkit.onReady(startAd);

function startAd() {
	checkForAndroid2();
	initializeVariables();
	addEventListeners();
	getEscapeToHideStatus();
}

function checkForAndroid2() {
	if ((/android 2/i).test(navigator.userAgent)) {
		document.body.className += "android2";
	}
}

function initializeVariables() {
	instructions = document.getElementById("instructions");
}

function addEventListeners() {

	
	var colorSwatches = document.getElementsByClassName("color-swatch");
	var colorSwatchLabels = document.getElementsByClassName("color-swatch-label");
	
	for (var i = 0; i < colorSwatches.length; i++) {
		colorSwatches[i].onclick = handleSwatchClick;
		if (!colorSwatches[i].labels) {
			colorSwatches[i].labels = [];
			colorSwatches[i].labels.push(colorSwatchLabels[i]);
		}
	}
	window.addEventListener("message", handleMessage, false);
}

function getEscapeToHideStatus() {
	EB._sendMessage("getDimmerEscapeToHideStatus");
}

function handleSwatchClick(e) {
	if (isOn && lastSelectedSwatch === e.target) {
		hideDimmer();
	}
	else {
		lastSelectedSwatch = e.target;
		showDimmer();
	}
}

function hideDimmer() {
	isOn = false;
	if (lastSelectedSwatch) {
		lastSelectedSwatch.checked = false;
	}
	EB._sendMessage("hideDimmer");
	EB.userActionCounter("HideDimmer");
}

function showDimmer() {
	// Handle Feature Tracking
	trackAdFeatures('impression', 'AF_' + scriptName + '_' + blockId);
	setInstructions("click again to hide");
	isOn = true;
	var color = window.getComputedStyle(lastSelectedSwatch.labels[0]).getPropertyValue("background-color");
	EB._sendMessage("showDimmer", {color: color});
	EB.userActionCounter("ShowDimmer");
}

function setInstructions(text) {
	if (instructions.textContent) {
		instructions.textContent = text;
	}
	else if (instructions.innerText) {
		instructions.innerText = text;
	}
	else if (instructions.innerHtml) {
		instructions.innerHtml = text;
	}
}

function handleMessage(e) {
	var event = JSON.parse(e.data);

	switch(event.type) {
		case "dimmerStatusUpdate":
			isOn = event.data.isOn;
			if (!isOn) {
				setInstructions("choose a color");
				if (lastSelectedSwatch && lastSelectedSwatch.checked) {
					lastSelectedSwatch.checked = false;
				}
			}
			break;
		case "dimmerEscapeToHideStatus":
			if (event.data.isEnabled) {
				addEscapeKeyEventListener();
			}
			break;
		case "dimmerEscapeToHide":
			EB.userActionCounter("HideDimmer");
			break;
	}
}

function addEscapeKeyEventListener() {
	window.document.onkeydown = escapeKeyDownListener;
	window.keyDown = escapeKeyDownListener;
}

function escapeKeyDownListener(e) {
	if (!e) {
		e = window.event;
	}

	if (isOn && e) {
		isOn = false;
		
		var keyCode = e.charCode || e.keyCode || e.which || null;
	
		if (e) {
			var escapeKeyChar = 27;
			var keyChar = e.charCode || e.keyCode || e.which || null;
			if (keyChar === escapeKeyChar) {
				hideDimmer();
			}
		}
	}
}

// DO NOT REMOVE THE FOLLOWING 
// Track Ad Features - accepts interaction name and impression type
function trackAdFeatures(_interaction, _noun) { 
	// Establish var to track local mode
	var isServed;
	// Verify ad is not local
	try { isServed = EB._isServingMode(); } catch (err) {}
	
	if (isServed && trackOnce) 
	{ 
		try 
		{
			trackOnce = false;
			// Grab Ad ID
			var adId = EB._adConfig.adId;
			// Grab Session ID
			var sId = EB._adConfig.sID; 
			// Build Tracking Pixel
			var trackingPixel = "https://bs.serving-sys.com/BurstingPipe/adServer.bs?cn=tf&c=19&mc=imp&pli=16479316&PluID=0&ord=%time%&rtu=-1&pcp=$$sID=" + sId + "|adID=" + adId + "|interactionName=" + _interaction + "|noun=" + _noun + "$$"; 
			// Fire Tracking Pixel by creating a new image.
			new Image().src = trackingPixel; 
		} 
			catch (err) 
		{}
	}
}